﻿using System;
using System.Diagnostics;
using System.IO;

namespace DF
{
	public delegate double msTx(NoeudDF pere, Position p, double r, double lZ);


	public class NoeudDF
	{
		public static Random gen = new Random();

		public static double Prod(double u, double v)
		{
			if (u < v) { double aux = u; u = v; v = aux; 
			}

			if (double.IsPositiveInfinity(v)) { return double.PositiveInfinity; }

			if (u<0){ return u + v - Math.Log(1+Math.Exp(u)+Math.Exp(v)); }

			return v - Math.Log(1 + Math.Exp(-u) + Math.Exp(v-u));
		}

		public static double Prod0(double[] u)
		{
			double re = u[0];
			for (int i = 1; i < u.Length; i++)
			{
				re = Prod(re, u[i]);
			}
			return re;
		}

		public static double Prod1(double[] u)
		{
			double[] v = new double[u.Length];
			for (int i = 0; i < u.Length; i++)
			{
				v[i] = -u[i];
			}
			return -Prod0(v);
		}

		public static double Llog(double u)
		{
			if (u < 0) { return u - Math.Log(1 + Math.Exp(u)); }
			if (u > 10) { return -Math.Exp(-u); }
			return -Math.Log(1 + Math.Exp(-u));
		}

		public static double Puiss(double u, double k){
			if (u<0){
				return u*k-Math.Log(Math.Pow(1+Math.Exp(u),k)-Math.Exp(u*k));
			}
			if (u<Math.Log(k)+ 4.6){ return -Math.Log(Math.Pow(1 + Math.Exp(-u), k) - 1); }
			return u - Math.Log(k);
		}

		public static double Div(double u, double v){
			//if (double.IsNegativeInfinity(v) || u > v) { Console.WriteLine("Problème de division " + u + " "+ v); }
			if (u >= v) { return Double.PositiveInfinity;}
			if (double.IsPositiveInfinity(v)) { return u;}
			double aux = (v < 0) ? Math.Log(1 + Math.Exp(v)) : (v + Math.Log(1 + Math.Exp(-v)));
			return aux - v + u - Math.Log(1 - Math.Exp(u - v));
		}

		//static double[] m = new double[PositionP4.nbCo * PositionP4.nbLi + 1];
		//static double[] s = new double[PositionP4.nbCo * PositionP4.nbLi + 1];

		//static NoeudDF(){
		//	string cd = Directory.GetCurrentDirectory();
		//	FileStream fs = File.OpenRead(cd + "/msP4_nbCo" + PositionP4.nbCo + "_nbLi" + PositionP4.nbLi);
		//	BinaryReader br = new BinaryReader(fs);
		//	for (int k = 0; k <= PositionP4.nbCo * PositionP4.nbLi; k++)
		//	{
		//		m[k] = br.ReadDouble();
		//		s[k] = br.ReadDouble();
		//		Console.WriteLine("m[{0}]={1} s[{0}]={2}", k, m[k], s[k]);
		//	}
		//	fs.Close();
		//}

		static public int compteur;
		static public int nbpb;
		static public int profpb;

		public Position p;
		public NoeudDF pere;
		public NoeudDF[] fils;
		public int cross, win;
		public int indiceMeilleurFils;
		double rFilsIni;
		double r;
		double rold;

		double lZ, lZfilsIni;
		double[] lUfils, lU2Zfils;


		public NoeudDF(NoeudDF pere, Position p, double r, double lZ, msTx phim, msTx logs)
		{
			compteur++;
			this.pere = pere;
			this.p = p;
			this.r = r;
			this.lZ = lZ;

			if (p.Eval != Resultat.indetermine) {
				this.lZ = double.NegativeInfinity; }

			fils = new NoeudDF[p.NbCoups];

			rFilsIni = 0; 
			lZfilsIni = 1;

			lUfils = new double[p.NbCoups];
			lU2Zfils = new double[p.NbCoups];

			if (p.Eval == Resultat.indetermine)
			{
				if (phim != null) { rFilsIni = phim(pere, p, r, lZ); }
				if (logs != null) { lZfilsIni = logs(pere, p, rFilsIni, lZ); }

				if (p.j1aletrait)
				{
					lUfils[0] = (p.NbCoups - 1) * Llog(-rFilsIni);
					for (int i = 1; i < lUfils.Length; i++) { lUfils[i] = lUfils[0]; }
				}
				else {
					lUfils[0] = (p.NbCoups - 1) * Llog(rFilsIni);
					for (int i = 1; i < lUfils.Length; i++) { lUfils[i] = lUfils[0]; }
				}
			}
		}


		public double R
		{
			get { return r; }
			set { rold = r; r = value;
				if (rold == r) { nbpb++; profpb += p.Profondeur; }//Console.WriteLine(r - r0);};
			}
		}

		public void CalculR()
		{
			
			//if (p.j1aletrait)
			//{
			//	double l = lUfils[indiceMeilleurFils] + Llog(-rFils(indiceMeilleurFils));
			//	if (l > 0) { Console.WriteLine(l);Console.ReadLine(); l = 0; };
			//	R = -(l - Math.Log(1 - Math.Exp(l)));
			//}
			//else{
			//	double l = lUfils[indiceMeilleurFils] + Llog(rFils(indiceMeilleurFils));
			//	if (l > 0) { Console.WriteLine(l); Console.ReadLine(); l = 0; }
			//	R = (l - Math.Log(1 - Math.Exp(l)));
			//}
			double[] u = new double[fils.Length];
			double[] ua = new double[fils.Length];
			for (int i = 0; i < u.Length; i++)
			{
				u[i] = rFils(i);
				ua[i] = Math.Abs(u[i]);
			}
			Array.Sort(ua, u);

			if (p.j1aletrait)
			{
				R = Prod1(u);
			}
			else {
				R = Prod0(u);
			}
		}

		public void CalculUfils()
		{
			if (fils.Length == 1) { lUfils[0] = 0; return; }
			if (p.j1aletrait)
			{
				double aux = Llog(-fils[indiceMeilleurFils].r) - Llog(-fils[indiceMeilleurFils].rold);
				if (double.IsNaN(aux)){
					Console.WriteLine(this);
					Console.WriteLine();
					Console.WriteLine(fils[indiceMeilleurFils]);
					Console.WriteLine(Llog(-fils[indiceMeilleurFils].r) + "  " + Llog(-fils[indiceMeilleurFils].rold));
					Console.ReadLine();
				}
				for (int i = 0; i < fils.Length; i++)
				{ 
					if (i!=indiceMeilleurFils){
						lUfils[i] += aux;
					}
				}
			}
			else
			{
				double aux = Llog(fils[indiceMeilleurFils].r) - Llog(fils[indiceMeilleurFils].rold);
				if (double.IsNaN(aux))
				{
					Console.WriteLine(this);
					Console.WriteLine();
					Console.WriteLine(fils[indiceMeilleurFils]);
					Console.WriteLine(Llog(fils[indiceMeilleurFils].r) + "  " + Llog(fils[indiceMeilleurFils].rold));
					Console.ReadLine();
				}
				for (int i = 0; i < fils.Length; i++)
				{
					if (i != indiceMeilleurFils)
					{
						lUfils[i] += aux;
					}
				}
			}
		}

		public void CalculU2Zfils()
		{
			for (int i = 0; i < fils.Length; i++)
			{
				lU2Zfils[i] = 2 * lUfils[i] + lZfils(i);
			}
		}

		public void CalculZ()
		{
			lZ = lU2Zfils[0];
			for (int i = 1; i < fils.Length; i++)
			{
				if (lU2Zfils[i] > lZ) { lZ = lU2Zfils[i]; }
			}
		}

		public double lZfils(int i)
		{
			if (fils[i] != null) { return fils[i].lZ; }
			else {
				return lZfilsIni;
			}
		}

		double rFils(int i)
		{
			if (fils[i] != null) { return fils[i].R; }
			else {
				return rFilsIni;
			}
		}

		public void CalculMeilleurFils()
		{
			indiceMeilleurFils = gen.Next(fils.Length);
			double sM = rFils(indiceMeilleurFils);
			double s;
			if (p.j1aletrait)
			{
				for (int i = 0; i < fils.Length; i++)
				{
					s = rFils(i);
					if (s > sM) { sM = s; indiceMeilleurFils = i; }
				}

				if (double.IsNegativeInfinity(sM)){
					for (int i = 0; i < fils.Length; i++)
					{ 
						if (fils[i].cross>fils[indiceMeilleurFils].cross){indiceMeilleurFils = i;}
					}
				}
			}
			else {
				for (int i = 0; i < fils.Length; i++)
				{
					s = rFils(i);
					if (s < sM) { sM = s; indiceMeilleurFils = i; }
				}
				if (double.IsPositiveInfinity(sM))
				{
					for (int i = 0; i < fils.Length; i++)
					{
						if (fils[i].cross > fils[indiceMeilleurFils].cross) { indiceMeilleurFils = i; }
					}
				}
			}
		}

		public void CalculMeilleurFils2()
		{
			indiceMeilleurFils = gen.Next(fils.Length);
			double sM = lU2Zfils[indiceMeilleurFils];
			double s;
			for (int i = 0; i < fils.Length; i++)
			{
				s = lU2Zfils[i];
				if (s > sM) { sM = s; indiceMeilleurFils = i; }
			}
		}


		public NoeudDF MeilleurFils(msTx phim, msTx logs)
		{
			return InstancierFils(indiceMeilleurFils, phim,  logs);
		}


		public NoeudDF InstancierFils(int i,msTx phim, msTx logs)
		{
			if (fils[i] != null) { return fils[i]; }
			fils[i] = new NoeudDF(this, p.PositionFille(i),rFilsIni, lZfilsIni, phim, logs);
			return fils[i];
		}

		public override string ToString()
		{
			string s = "r=" + r + "\n";
			s += "lZ=" + lZ + "\nFils : ";
			for (int l = 0; l < fils.Length; l++)
			{
				s = s + (rFils(l)) + " ";
			}
			s += "\n";
			for (int k = 0; k < fils.Length; k++)
			{
				if (fils[k] != null)
				{
					s += (fils[k].win + "/" + fils[k].cross+"  ");
				}
				else s += (0 + "/" + 0 + " ");
			}

			return s;
		}
	}

	public class JDF : Joueur
	{
		static Stopwatch sw = new Stopwatch();

		protected int n;
		protected int temps;
		protected double a = 0;
		NoeudDF racine;

		protected msTx phim, logs;

		int nbiter, nbcoups;

		public JDF(int n, int temps)
		{
			this.n = n;
			this.temps = temps;
		}

		public JDF(int n, int temps, msTx phim, msTx logs)
		{
			this.n = n;
			this.temps = temps;
			this.phim = phim;
			this.logs = logs;
		}

		public override void NouvellePartie()
		{
			racine = null;
			nbiter = 0;
			nbcoups = 0;
		}

		public override float Nbitmoy
		{
			get
			{
				return (1F*nbiter)/nbcoups;
			}
		}



		public override int Jouer(Position p, bool affichage)
		{
			NoeudDF.compteur = 0;
			NoeudDF.nbpb = 0;
			NoeudDF.profpb = 0;

			if (racine == null) {
				double aux = a;
				if (!p.j1aletrait){
					aux = -JDFmono.Racine(-a, p.NbCoups);
				}
				racine = new NoeudDF(null, p, aux, 0, phim, logs);
			}
			else {
				int k = 0;
				for (k = 0; k < racine.fils.Length; k++)
				{
					if (p.Equals(racine.p.PositionFille(k))) break;
				}
				racine = racine.InstancierFils(k,phim,logs);
				racine.pere = null;
				//Console.WriteLine(racine);
				//Console.WriteLine();
			}

			//NoeudDF racine = new NoeudDF(null, p, a, 1,phim,logs);
			NoeudDF no;
			int i;

			sw.Restart(); NoeudDF.compteur = 0;

			for (i = 0; i < n; i++)
			{
                if (sw.ElapsedMilliseconds > temps || double.IsInfinity(racine.R))
                {
                    break;
                }
				no = racine;
				do
				{
					no.CalculMeilleurFils2();
					no = no.MeilleurFils(phim, logs);

				} while (no.p.Eval == Resultat.indetermine);

				double res = double.NegativeInfinity;

				if (p.j1aletrait)
				{
					if (no.p.Eval == Resultat.j1gagne) { res = double.PositiveInfinity; }
				}
				else { res = double.PositiveInfinity; if (no.p.Eval == Resultat.j0gagne) { res = double.NegativeInfinity; } }


				no.cross++; no.win += (double.IsPositiveInfinity(res)) ? 1 : 0; no.R = res;

				no = no.pere;
				while (no != null)
				{
					no.cross++;
					no.win += (double.IsPositiveInfinity(res)) ? 1 : 0;
					no.CalculUfils();
					no.CalculR();
					no.CalculU2Zfils();
					no.CalculZ();
					no = no.pere;
				}

			}              

			if (nbcoups == 0) { nbiter += i;nbcoups++;}

			no = null;
			racine.CalculMeilleurFils();
			if (affichage)
			{
				Console.WriteLine("{0} itérations en {1} ms, {2} nœuds visités", i, sw.ElapsedMilliseconds, NoeudDF.compteur);
				Console.WriteLine("nb pb= " + NoeudDF.nbpb);
				Console.WriteLine(racine);
				//Console.WriteLine(racine.MeilleurFils(phim, logs));
			}
			int rep = racine.indiceMeilleurFils;
			racine = racine.MeilleurFils(phim,logs);
			racine.pere = null;
			return rep;
		}
	}

	public class JDFGW: JDF{

		double[] m = new double[PositionP4.nbCo * PositionP4.nbLi + 1];
		double[] s = new double[PositionP4.nbCo * PositionP4.nbLi + 1];
		
		public JDFGW(int n, int temps, bool suisJ1) : base(n, temps)
		{
			string cd = Directory.GetCurrentDirectory();
			string aux = suisJ1 ? "1" : "0";
			FileStream fs = File.OpenRead(cd + "/msP4pourJ"+aux+"_nbCo" + PositionP4.nbCo + "_nbLi" + PositionP4.nbLi + "_lmin" + PositionP4.lmin1);
			BinaryReader br = new BinaryReader(fs);
			Console.WriteLine("JDFGW charge m et s");
			for (int k = 0; k <= PositionP4.nbCo * PositionP4.nbLi; k++)
			{
				m[k] = br.ReadDouble();
				s[k] = br.ReadDouble();
				Console.WriteLine("m[{0}]={1} s[{0}]={2}", k, m[k], s[k]);
			}
			fs.Close();
			phim= (pere, p, r, lZ) => m[p.Profondeur + 1];
			logs= (pere, p, r, lZ) => s[p.Profondeur+1];
		}
		
	}

	public class JDFGWbiz : JDF
	{

		double[] m = new double[PositionP4.nbCo * PositionP4.nbLi + 1];
		double[] s = new double[PositionP4.nbCo * PositionP4.nbLi + 1];

		public JDFGWbiz(int n, int temps, bool suisJ1) : base(n, temps)
		{
			string cd = Directory.GetCurrentDirectory();
			string aux = suisJ1 ? "0" : "1";
			FileStream fs = File.OpenRead(cd + "/msP4pourJ" + aux + "_nbCo" + PositionP4biz.nbCo + "_nbLi" + PositionP4biz.nbLi + "_lmin" + PositionP4biz.lmin1);
			BinaryReader br = new BinaryReader(fs);
			Console.WriteLine("JDFGW charge m et s");
			for (int k = 0; k <= PositionP4biz.nbCo * PositionP4biz.nbLi; k++)
			{
				m[k] = -br.ReadDouble();
				s[k] = br.ReadDouble();
				Console.WriteLine("m[{0}]={1} s[{0}]={2}", k, m[k], s[k]);
			}
			fs.Close();
			phim = (pere, p, r, lZ) => m[p.Profondeur + 1];
			logs = (pere, p, r, lZ) => s[p.Profondeur + 1];
		}

	}

	public class JDFmono : JDF{
		
		public static double Racine(double u, double d)
		{
			//if (double.IsNegativeInfinity(u))
			if (u <= -20)
			{
				return u / d - Math.Log(1 - Math.Exp(u / d));
			}
			if (u > 20)
			{
				return Math.Log(d) + u;
			}
			else return -Math.Log(Math.Pow(1 + Math.Exp(-u), 1.0 / d) - 1);
		}

		public JDFmono(double a, int n, int temps, msTx logs) : base(n, temps, (pere, p, r, lZ) => p.j1aletrait ? -Racine(-r, p.NbCoups) : Racine(r, p.NbCoups), logs)
		{
			this.a = a;
		}

		public override string ToString()
		{
			return string.Format("JDFmono[a={0}, n={1},temps={2}]", a, n, temps);
		}
	}

	public class JDFPearl : JDF
	{

		public static double Racine(double u, double d)
		{
			//if (double.IsNegativeInfinity(u))
			if (u <= -20)
			{
				return u / d - Math.Log(1 - Math.Exp(u / d));
			}
			if (u > 20)
			{
				return Math.Log(d) + u;
			}
			else return -Math.Log(Math.Pow(1 + Math.Exp(-u), 1.0 / d) - 1);
		}

		double b;

		public JDFPearl(double a, double b, int n, int temps) : base(n, temps, (pere, p, r, lZ) => p.j1aletrait ? -Racine(-r, p.NbCoups) : Racine(r, p.NbCoups), (pere, p, r, lZ) =>
			lZ - b * ((p.NbCoups - 1.0)) * (p.j1aletrait ? NoeudDF.Llog(-r) : NoeudDF.Llog(r)))
		{
			this.b = b;
			this.a = a;
		}

		public override string ToString()
		{
			return string.Format("JDFPearl[a={0}  b={1}  n={2}  temps={3}]", a, b, n, temps);
		}
	}


}
