﻿using System;
namespace DF
{
	public class PositionHex : Position
	{
		public const byte nbLi = 14;
		public const byte nbCo = 14;
		public const byte nbCases = nbLi*nbCo;

		public byte[,] cases = new byte[nbLi, nbCo];

		public PositionHex(bool j1aletrait=true) : base(j1aletrait)
		{
			Profondeur = 0;
			NbCoups = nbCases;
		}

		public PositionHex(bool j1aletrait, byte[,] cases, int pro) : base(j1aletrait)
		{
			this.cases = cases;
			Profondeur = pro;
			NbCoups = nbCases - pro;
			Eval = Evalu();
		}

		public override bool Equals(object obj)
		{
			PositionHex q = (PositionHex)obj;
			if (j1aletrait != q.j1aletrait) return false;

			for (int i = 0; i < nbLi; i++)
			{
				for (int j = 0; j < nbCo; j++)
				{
					if (cases[i, j] != q.cases[i, j]) { return false; }
				}
			}
			return true;
		}

		public override Position PositionFille(int i)
		{
			int k = 0, l=0;
			int compteur = -1;
			for (k = 0; k < nbLi && compteur<i ;k++){
				for (l = 0;l<nbCo && compteur<i; l++){
					if (cases[k, l] == 0) { compteur++;}
				}
			}
			k--; l--;
			byte[,] casesFille =(byte[,]) cases.Clone();
			casesFille[k, l] = (byte ) (j1aletrait ? 1 : 2);
			return new PositionHex(!j1aletrait, casesFille, Profondeur + 1);
		}

		public byte Hexa(int i, int j){
			if (i < -1 || i > nbLi || j < -1 || j > nbCo) return 0;
			if ((i == -1 || i == nbLi) && (j == -1 || j == nbCo)) return 0;
			if (i == -1 || i == nbLi) return 1;
			if (j == -1 || j == nbCo) return 2;
			return cases[i, j];
		}

		public Resultat Evalu() {
			Resultat re = EvaluOr();
            return re;
			//if (re == Resultat.indetermine) return re;
			//if (re == Resultat.j1gagne) return Resultat.j0gagne;
			//return Resultat.j1gagne;
		}

		public Resultat EvaluOr(){

			int jhaut = 0;
			while (jhaut<nbCo &&cases[0, jhaut] != 1) { jhaut++;}
			int jbas = 0;
			while (jbas < nbCo && cases[nbLi-1, jbas] != 1) { jbas++; }

			if (jhaut<nbCo && jbas< nbCo)
			{
				int i = -1, j = 0, d=5;
				int ibis=0, jbis=0;
				do 
				{
					d = (d + 3) % 6;
					do
					{
						d = (d + 1) % 6;
						switch (d)
						{
							case 0: ibis=i; jbis= j + 1; break;
							case 1: ibis = i - 1; jbis= j + 1; break;
							case 2: ibis=i - 1; jbis = j; break;
							case 3: ibis=i; jbis= j - 1; break;
							case 4: ibis = i + 1; jbis= j - 1; break;
							case 5: ibis=i + 1; jbis = j; break;
						}
					}
					while (Hexa(ibis, jbis) != 1);

					i = ibis; j = jbis;
					if (i == nbLi) return Resultat.j1gagne;
					//Console.WriteLine("({0},{1})", i+1, j+1); Console.ReadKey();
				}
				while (!(i == -1 && j == 0));
			}

			int igauche = 0;
			while (igauche < nbLi && cases[igauche, 0] != 2) { igauche++; }
			int idroit = 0;
			while (idroit < nbLi && cases[idroit, nbCo-1] != 2) { idroit++; }

			if (igauche < nbLi && idroit < nbLi)
			{
				int i = 0, j = -1, d = 5;
				int ibis = 0, jbis = 0;
				do
				{
					d = (d + 3) % 6;
					do
					{
						d = (d + 1) % 6;
						switch (d)
						{
							case 0: ibis = i; jbis = j + 1; break;
							case 1: ibis = i - 1; jbis = j + 1; break;
							case 2: ibis = i - 1; jbis = j; break;
							case 3: ibis = i; jbis = j - 1; break;
							case 4: ibis = i + 1; jbis = j - 1; break;
							case 5: ibis = i + 1; jbis = j; break;
						}
					}
					while (Hexa(ibis, jbis) != 2);

					i = ibis; j = jbis;
					if (j == nbCo) return Resultat.j0gagne;
					//Console.WriteLine("({0},{1})", i + 1, j + 1); Console.ReadKey();
				}
				while (!(i == 0 && j == -1));
			}

			return Resultat.indetermine;
		}

		public override void Affiche()
		{
			char col = 'A';
			Console.ForegroundColor = ConsoleColor.Red;
			Console.Write("  ");
			for (int j = 0; j < nbCo; j++)
			{
				Console.Write(col+"   ");
				col++;
			}
			Console.ForegroundColor = ConsoleColor.Black;

			string s = "";

			for (int i = 0; i < nbLi;i++){
				Console.WriteLine();
				Console.ForegroundColor = ConsoleColor.Blue;
				if (i < 9)
				{
					Console.Write(s + (i + 1) + "   ");
				}
				else{
					Console.Write(s + (i + 1) + "  ");
				}
				Console.ForegroundColor = ConsoleColor.Black;
				for (int j = 0; j < nbCo; j++)
				{
					//Console.Write("o   ");
					switch(cases[i,j]){
						case 0: Console.Write("o———");break;
						case 1: Console.ForegroundColor = ConsoleColor.Red; Console.Write("§"); 
								Console.ForegroundColor = ConsoleColor.Black; Console.Write("–––"); break;
						case 2: Console.ForegroundColor = ConsoleColor.Blue; Console.Write("§");
								Console.ForegroundColor = ConsoleColor.Black; Console.Write("–––"); break;
					}
				}
				Console.ForegroundColor = ConsoleColor.Blue;
				Console.Write( (i + 1));
				Console.ForegroundColor = ConsoleColor.Black;
				s += "  ";
			}
			Console.WriteLine();
			col = 'A';
			Console.ForegroundColor = ConsoleColor.Red;
			Console.Write(s+"    ");
			for (int j = 0; j < nbCo; j++)
			{
				Console.Write(col + "   ");
				col++;
			}
			Console.ForegroundColor = ConsoleColor.Black;
			string jou;
			if (j1aletrait)
				jou = "j1";
			else jou = "j0";
			Console.Write("-\n");
			Console.WriteLine(jou + " (" + (j1aletrait ? "rouge" : "bleu") + ") a le trait. Profondeur = " + Profondeur + " NbCoups=" + NbCoups);
		}
	}
}
