﻿using System;
namespace DF
{
	public class PositionP4 : Position
	{
		public static byte lmin1=4 ;
		public static byte lmin2=lmin1 ;
		public static byte nbLi=6;
		public static byte nbCo=7 ;


		public static string Des(){
			return String.Format("P4 nbLi={0} nbCo={1} lmin={2}", nbLi, nbCo, lmin1);
		}

		public byte[,] cases = new byte[nbLi, nbCo];

		public PositionP4(bool j1aletrait=true) : base(j1aletrait)
		{
			Eval = Evalu();
			CalculNbcoups();
			Profondeur = 0;
		}

		public PositionP4(byte[,] cases, bool j1aletrait, int pro) : base(j1aletrait)
		{
			for (int i = 0; i < nbLi; i++)
			{
				for (int j = 0; j < nbCo; j++)
				{
					this.cases[i, j] = cases[i, j];
				}
			}
			Profondeur = pro;
			Eval = Evalu();
			CalculNbcoups();
		}

		public override bool Equals(object obj)
		{
			PositionP4 q = (PositionP4)obj;
			if (j1aletrait != q.j1aletrait) return false;
			for (int i = 0; i < nbLi; i++)
			{
				for (int j = 0; j < nbCo; j++)
				{
					if (cases[i, j] != q.cases[i, j]) { return false; }
				}
			}
			return true;
		}

		void CalculNbcoups()
		{
			NbCoups = 0;
			if (Eval != Resultat.indetermine) return;
			for (int j = 0; j < nbCo; j++)
			{
				if (cases[nbLi - 1, j] == 0)
					NbCoups++;
			}
		}


		public override string ToString()
		{
			string jou;
			if (j1aletrait)
				jou = "j1";
			else jou = "j0";
			string s = "\n| ";
			for (int j = 0; j < nbCo; j++)
			{
				s = s + " " + (j + 1) + " ";
			}
			s = s + "\n";
			for (int j = 0; j < nbCo; j++)
			{
				s = s + "---";
			}
			s = s + "-\n";
			for (int i = nbLi - 1; i >= 0; i--)
			{
				s = s + "| ";
				for (int j = 0; j < nbCo; j++)
				{
					switch (cases[i, j])
					{
						case (0):
							s = s + "   ";
							break;
						case (1):
							//Console.ForegroundColor = ConsoleColor.Red;
							s = s + " 1 ";
							//Console.ForegroundColor = ConsoleColor.Black;
							break;
						case (2):
							s = s + " 0 ";
							break;
					}
				}
				s = s + "\n";
			}
			for (int j = 0; j < nbCo; j++)
			{
				s = s + "---";
			}
			s = s + "-\n";
			return s + jou + " a le trait.\n";
		}

		public override void Affiche()
		{
			string jou;
			if (j1aletrait)
				jou = "j1";
			else jou = "j0";
			Console.Write("\n| ");
			for (int j = 0; j < nbCo; j++)
			{
				Console.Write(" " + (char)(j + 'a') + " ");
			}
			Console.Write("\n");
			for (int j = 0; j < nbCo; j++)
			{
				Console.Write("---");
			}
			Console.Write("-\n");
			for (int i = nbLi - 1; i >= 0; i--)
			{
				Console.Write("| ");
				for (int j = 0; j < nbCo; j++)
				{
					switch (cases[i, j])
					{
						case (0):
							Console.Write(" . ");
							break;
						case (1):
							Console.ForegroundColor = ConsoleColor.Red;
							Console.Write(" 1 ");
							Console.ForegroundColor = ConsoleColor.Black;
							break;
						case (2):
							Console.ForegroundColor = ConsoleColor.DarkBlue;
							Console.Write(" 0 ");
							Console.ForegroundColor = ConsoleColor.Black;
							break;
					}
				}
				Console.Write("\n");
			}
			for (int j = 0; j < nbCo; j++)
			{
				Console.Write("---");
			}
			Console.Write("-\n");
			Console.WriteLine(jou + " (" + (j1aletrait ? "rouge" : "bleu") + ") a le trait, Profondeur = " + Profondeur + ", NbCoups=" + NbCoups);
		}


		public  Resultat Evalu()
		{
			int nb0 = 0;
			int i = 0, j = 0, lj1 = 0, lj2 = 0;

			// horizontales
			for (i = 0; i < nbLi; i++)
			{
				lj1 = 0; lj2 = 0;
				for (j = 0; j < nbCo; j++)
				{
					switch (cases[i, j])
					{
						case (1):
							lj1++; if (lj1 >= lmin1) return (Resultat.j1gagne);
							lj2 = 0;
							break;
						case (2):
							lj2++; if (lj2 >= lmin2) return (Resultat.j0gagne);
							lj1 = 0;
							break;
						case (0):
							nb0++;
							lj1 = 0;
							lj2 = 0;
							break;
					}

				}
			}


			// verticales	
			for (j = 0; j < nbCo; j++)
			{
				lj1 = 0; lj2 = 0;
				for (i = 0; i < nbLi; i++)
				{
					switch (cases[i, j])
					{
						case (1):
							lj1++; if (lj1 >= lmin1) return (Resultat.j1gagne);
							lj2 = 0;
							break;
						case (2):
							lj2++; if (lj2 >= lmin2) return (Resultat.j0gagne);
							lj1 = 0;
							break;
						case (0):
							lj1 = 0;
							lj2 = 0;
							break;
					}

				}
			}

			// diagonales i=j+cste avec cste>=0	
			for (i = 0; i < nbLi; i++)
			{
				lj1 = 0; lj2 = 0;
				for (j = 0; j < nbCo && i + j < nbLi; j++)
				{
					switch (cases[i + j, j])
					{
						case (1):
							lj1++; if (lj1 >= lmin1) return (Resultat.j1gagne);
							lj2 = 0;
							break;
						case (2):
							lj2++; if (lj2 >= lmin2) return (Resultat.j0gagne);
							lj1 = 0;
							break;
						case (0):
							lj1 = 0;
							lj2 = 0;
							break;
					}

				}
			}

			// diagonales i=j+cste avec cste<0	
			for (j = 1; j < nbCo; j++)
			{
				lj1 = 0; lj2 = 0;
				for (i = 0; i < nbLi && i + j < nbCo; i++)
				{
					switch (cases[i, i + j])
					{
						case (1):
							lj1++; if (lj1 >= lmin1) return (Resultat.j1gagne);
							lj2 = 0;
							break;
						case (2):
							lj2++; if (lj2 >= lmin2) return (Resultat.j0gagne);
							lj1 = 0;
							break;
						case (0):
							lj1 = 0;
							lj2 = 0;
							break;
					}

				}
			}

			// diagonales j=cste-i avec cste>=0	
			for (i = 0; i < nbLi; i++)
			{
				lj1 = 0; lj2 = 0;
				for (j = 0; j < nbCo && i >= j; j++)
				{
					switch (cases[i - j, j])
					{
						case (1):
							lj1++; if (lj1 >= lmin1) return (Resultat.j1gagne);
							lj2 = 0;
							break;
						case (2):
							lj2++; if (lj2 >= lmin2) return (Resultat.j0gagne);
							lj1 = 0;
							break;
						case (0):
							lj1 = 0;
							lj2 = 0;
							break;
					}

				}
			}

			// diagonales j=cste-i avec cste<0	
			for (j = 1; j < nbCo; j++)
			{
				lj1 = 0; lj2 = 0;
				for (i = 0; i < nbLi && j + i < nbCo; i++)
				{
					switch (cases[nbLi - i - 1, j + i])
					{
						case (1):
							lj1++; if (lj1 >= lmin1) return (Resultat.j1gagne);
							lj2 = 0;
							break;
						case (2):
							lj2++; if (lj2 >= lmin2) return (Resultat.j0gagne);
							lj1 = 0;
							break;
						case (0):
							lj1 = 0;
							lj2 = 0;
							break;
					}

				}
			}
			if (nb0 == 0)
				return (Resultat.partieNulle);

			return (Resultat.indetermine);
		}


		public override Position PositionFille(int i)
		{
			int k = 0;
			PositionP4 q = new PositionP4(cases, !j1aletrait, Profondeur+1);

			for (int j = 0; j < nbCo; j++)
			{
				if (cases[nbLi - 1, j] == 0)
				{
					if (k == i)
					{
						int m = nbLi - 1;
						while (m >= 0 && cases[m, j] == 0)
							m--;
						m++;
						q.cases[m, j] = (j1aletrait) ? (byte)1 : (byte)2;
						q.Eval = q.Evalu();
						q.CalculNbcoups();
						return q;
					}
					k++;
				}
			}

			Console.WriteLine("ERREUR");
			throw new NotImplementedException();
		}
	}
}
