﻿using System;
using System.Collections.Generic;
namespace DF
{
	public class Numero : IComparable<Numero>
	{
		public byte[] nume;

		public Numero(byte[] nume)
		{
			this.nume = nume;
		}

		public Numero Incrementer(int d){
			byte[] nu = (byte[])nume.Clone();
			int k = nu.Length-1;
			while (nu[k]==(d-1)){
				nu[k] = 0;
				k--;
			}
			nu[k]++;
			return new Numero(nu);
		}

		int IComparable<Numero>.CompareTo(Numero other)
		{
			if (nume.Length < other.nume.Length) { return -1;}
			if (nume.Length < other.nume.Length) { return 1; }
			for (int i = 0; i < nume.Length;i++){
				if (nume[i] < other.nume[i]) { return -1;}
				if (nume[i] > other.nume[i]) { return 1; }
			}
			return 0;
		}

		public Numero Fils(byte i){
			byte[] numefils = new byte[nume.Length + 1];
			Array.Copy(nume, numefils, nume.Length);
			numefils[nume.Length] = i;
			return new Numero( numefils);
		}

		public override string ToString()
		{
			string s = "Numéro : ";
			for (int i = 0; i < nume.Length;i++){
				s += nume[i] + ".";
			}
			return s;
		}
	}

	public class PositionPearl :Position
	{
		public static int d=2;
		public static int K=32;
		static double p;
		static Random gen = new Random();

		public static SortedDictionary<Numero, byte> feuilles; 

		static PositionPearl(){
            double aux = 0;
			for (int k = 0; k < K; k++){
				if (k % 2 == 0)
				{
					aux = -JDFmono.Racine(-aux, d);
				}
				else { aux = JDFmono.Racine(aux,d);}
			}
			p = Math.Exp(aux) / (1 + Math.Exp(aux));
            Console.WriteLine("K={0}, p={1}",K, p);// Console.ReadKey();
		}

		public static byte[] NotesMinMax(int nb1){
			int N =(int) Math.Pow(d, K);
			int nb;
			byte[] note;
			do
			{
				feuilles = new SortedDictionary<Numero, byte>();
				note = new byte[N];
				Numero nu = new Numero(new byte[K]);
				for (int i = 0; i < N; i++)
				{
					note[i] = (byte)((gen.NextDouble() <= p) ? 1 : 0);
					//Console.WriteLine(feuilles.Count+" "+ nu);
					feuilles.Add(nu, note[i]);
					if (i == N - 1) { break; }
					nu = nu.Incrementer(d);
				}
				for (int h = K - 1; h >= 1; h--)
				{
					byte[] aux = new byte[note.Length / d];
					for (int i = 0; i < aux.Length; i++)
					{
						aux[i] = note[d * i];
						if (h % 2 == 0)
						{
							for (int u = 1; u < d; u++)
							{
								if (note[d * i + u] > aux[i]) { aux[i] = note[d * i + u]; }
							}
						}
						else {
							for (int u = 1; u < d; u++)
							{
								if (note[d * i + u] < aux[i]) { aux[i] = note[d * i + u]; }
							}
						}
					}
					note = aux;
				}
				nb = 0;
				for (int i = 0; i < note.Length; i++) { nb += note[i]; }
			} while (nb != nb1);
			return note;
		}

		Numero num;

		public PositionPearl(bool j1aletrait) : base(j1aletrait)
		{
				num =new Numero( new byte[0]);
				NbCoups = d;
				Eval = Resultat.indetermine;
				feuilles = new SortedDictionary<Numero, byte>();
		}

		public PositionPearl(bool j1aletrait, Numero num) : base (j1aletrait){
			this.num = num;
			if (num.nume.Length < K) { NbCoups = d; Eval = Resultat.indetermine;}
			else
			{
				NbCoups = 0;
				byte res;
				if (!feuilles.TryGetValue(num,out res)){
					res = (byte)((gen.NextDouble() <= p) ? 1 : 0);
					feuilles.Add(num, res);
				}
				Eval = (res == 1) ? Resultat.j1gagne : Resultat.j0gagne;
			}
		}

		public override bool Equals(object obj)
		{
			PositionPearl other = (PositionPearl)obj;
			if (num.nume.Length < other.num.nume.Length) { return false; }
			if (num.nume.Length < other.num.nume.Length) { return false; }
			for (int i = 0; i < num.nume.Length; i++)
			{
				if (num.nume[i] < other.num.nume[i]) { return false; }
				if (num.nume[i] > other.num.nume[i]) { return false; }
			}
			return true;
		}

		public override void Affiche()
		{	
			string jou="";
			if (j1aletrait)
				jou = "j1";
			else jou = "j0";
			Console.WriteLine(jou+ "a le trait+  "+ feuilles.Count+ "feuilles  Numé : "+ num.ToString());
			//Console.WriteLine("Feuilles :");
			//foreach (Numero nu in feuilles.Keys){
			//	Console.Write(nu + " : " + feuilles[nu]+" ");
			//}
		}

		public override Position PositionFille(int i)
		{
			return new PositionPearl(!j1aletrait, num.Fils((byte) i));
		}
	}
}
