﻿//POUR COMPILER dmcs Program.cs JDF.cs JHumHas.cs JMCTS.cs PositionP4biz.cs PositionP4.cs Regle.cs PositionHex.cs PositionPearl.cs
//POUR EXECUTER mono --gc=sgen Program.exe

using System;
using System.Collections.Generic;
namespace DF
{
    public class Program
    {
        public static void Main(string[] args)
        {
            Example();
            //LargePearl();
            //SmallPearl();
            //ConnectFour();
            //ConnectFourSmallDegree();
            //ConnectFourLargeDegree();
            //ConnectFourLargeDegreeBis();
            //InverseConnectFour();
            //Hex();
        }


        public static void Example()
        {
			Joueur j1 = new JMCTSinf(1, 1, int.MaxValue, temps: 30);
			Joueur j0 = new JDFPearl(0, 0, int.MaxValue, temps: 30);
			Joueur jh = new JoueurHumainP4();
            Joueur jhh = new JoueurHumainHex();
            Duel(jh,j0, new PositionP4(), 1, true);
            Duel(j1, jhh, new PositionHex(), 1, true);
			Duel(j1, jh, new PositionP4biz(), 1, true);

		}

        public static void LargePearl()
        {
            PositionPearl.K = 32;
            Position p = new PositionPearl(true);
            int temps = 1;
            while (temps <= 64)
            {
                Exp(p, m0: 1, m1: 10, temps: temps, nbTour: 7, jdf: new JDFPearl(0, 2, int.MaxValue, temps));
                temps = 2 * temps;
            }
        }

        public static void SmallPearl()
        {
            PositionPearl.K = 16;
            Position p = new PositionPearl(true);
            int temps = 1;
            while (temps <= 32)
            {
                Exp(p, m0: 1, m1: 20, temps: temps, nbTour: 7, jdf: new JDFPearl(0, 2, int.MaxValue, temps));
                temps = 2 * temps;
            }
        }

        public static void ConnectFour()
        {
            PositionP4.lmin1 = 4;
            PositionP4.lmin2 = 4;
            PositionP4.nbLi = 6;
            PositionP4.nbCo = 7;
            Position p = new PositionP4(true);
            int temps = 1;
            while (temps <= 16)
            {
                Exp(p, m0: 1, m1: 10, temps: temps, nbTour: 7, jdf: new JDFmono(0, int.MaxValue, temps, null));
                temps = 2 * temps;
            }
        }

        public static void ConnectFourSmallDegree()
        {
            PositionP4.lmin1 = 3;
            PositionP4.lmin2 = 3;
            PositionP4.nbLi = 10;
            PositionP4.nbCo = 4;
            Position p = new PositionP4(true);
            int temps = 1;
            while (temps <= 16)
            {
                Exp(p, m0: 1, m1: 10, temps: temps, nbTour: 7, jdf: new JDFmono(0, int.MaxValue, temps, null));
                temps = 2 * temps;
            }
        }

		public static void ConnectFourLargeDegree()
		{
			PositionP4.lmin1 = 3;
			PositionP4.lmin2 = 3;
			PositionP4.nbLi = 15;
			PositionP4.nbCo = 15;
			Position p = new PositionP4(true);
			int temps = 1;
			while (temps <= 128)
			{
                Exp(p, m0: 1, m1: 10, temps: temps, nbTour: 7, jdf: new JDFmono(0, int.MaxValue, temps, null));
				temps = 2 * temps;
			}
		}

		public static void ConnectFourLargeDegreeBis()
		{
			PositionP4.lmin1 = 5;
			PositionP4.lmin2 = 5;
			PositionP4.nbLi = 6;
			PositionP4.nbCo = 15;
			Position p = new PositionP4(true);
			int temps = 1;
			while (temps <= 16)
			{
                Exp(p, m0: 1, m1: 10, temps: temps, nbTour: 7, jdf: new JDFmono(0, int.MaxValue, temps, null));
				temps = 2 * temps;
			}
		}

		public static void InverseConnectFour()
		{
			PositionP4biz.lmin1 = 5;
			PositionP4biz.lmin2 = 5;
			PositionP4biz.nbLi = 6;
			PositionP4biz.nbCo = 15;
			Position p = new PositionP4biz(true);
			int temps = 1;
			while (temps <= 4)
			{
                Exp(p, m0: 1, m1: 10, temps: temps, nbTour: 7, jdf: new JDFmono(0, int.MaxValue, temps, null));
				temps = 2 * temps;
			}
		}

		public static void Hex()
		{
			Position p = new PositionHex(true);
			int temps = 2;
			while (temps <= 8)
			{
                Exp(p, m0: 1, m1: 5, temps: temps, nbTour: 2, jdf: new JDFmono(0, int.MaxValue, temps, null));
				temps = 2 * temps;
			}
		}




		public static void Exp(Position p, int m0, int m1, int temps, int nbTour, JDF jdf)
        {
            Joueur[] particiInf = new Joueur[(m1 - m0 + 1) * (m1 - m0 + 2) / 2];
            Joueur[] particiOff = new Joueur[(m1 - m0 + 1) * (m1 - m0 + 2) / 2];

            int k = 0;
            for (int i = m0; i <= m1; i++)
            {
                for (int j = i; j <= m1; j++)
                {
                    particiInf[k] = new JMCTSinf(i * .5F, j * .5F, int.MaxValue, temps);
                    particiOff[k] = new JMCTSoff(i * .5F, j * .5F, int.MaxValue, temps);
                    k++;
                }
            }

            Championnat(particiInf, nbTour, p);

            Console.WriteLine("*************************");

            Championnat(particiOff, nbTour, p);

            Console.WriteLine("*************************");

            Joueur particiInfBest = particiInf[(m1 - m0 + 1) * (m1 - m0 + 2) / 2 - 1];
            Joueur particiOffBest = particiOff[(m1 - m0 + 1) * (m1 - m0 + 2) / 2 - 1];

            Duel(jdf, particiInfBest, p, 10000, false);

            Duel(jdf, particiOffBest, p, 10000, false);
        }

        public static void Duel(Joueur j1, Joueur j0, Position p, int N, bool affichage)
        {
            int nb1 = 0, nb2 = 0, nbn = 0;
            int nb1bis = 0, nb2bis = 0, nbnbis = 0;
            Partie partie = new Partie(j1, j0, null);
            Partie partie2 = new Partie(j0, j1, null);

            for (int i = 0; i < N; i++)
            {
                partie.NouveauMatch(p);
                partie.Commencer(affichage);
                switch (partie.r)
                {
                    case Resultat.j1gagne: nb1++; break;
                    case Resultat.j0gagne: nb2++; break;
                    case Resultat.partieNulle: nbn++; break;
                }
                partie2.NouveauMatch(p);
                partie2.Commencer(affichage);
                switch (partie2.r)
                {
                    case Resultat.j1gagne: nb1bis++; break;
                    case Resultat.j0gagne: nb2bis++; break;
                    case Resultat.partieNulle: nbnbis++; break;
                }
                if (p is PositionPearl) { PositionPearl.feuilles=new SortedDictionary<Numero, byte>(); }
            }
            Console.WriteLine("\n Sur {0} parties : {1} victoires {4}, {2} victoires {5}, {3} nulles", N, nb1, nb2, nbn, j1, j0);

            Console.WriteLine("\n Sur {0} parties : {1} victoires {4}, {2} victoires {5}, {3} nulles", N, nb1bis, nb2bis, nbnbis, j0, j1);

        }

        static void Championnat(Joueur[] partici, int nbTour, Position p)
        {
            int nbJ = partici.Length;

            float[] score1 = new float[nbJ];
            float[] score0 = new float[nbJ];
            float[] score = new float[nbJ];
            float[] nbitMoy = new float[nbJ];

            for (int k = 1; k <= nbTour; k++)
            {
                for (int i = 0; i < nbJ; i++)
                {
                    Console.Write(i + "/");
                    for (int j = i+1; j < nbJ; j++)
                    {
                        Partie partie = new Partie(partici[i], partici[j], p);
                        partie.Commencer(false);
                        switch (partie.r)
                        {
                            case Resultat.j1gagne: score1[i]++; break;
                            case Resultat.j0gagne: score0[j]++; break;

                        }
                        nbitMoy[i] += partici[i].Nbitmoy;
                        nbitMoy[j] += partici[j].Nbitmoy;

						partie = new Partie(partici[j], partici[i], p);
						partie.Commencer(false);
						switch (partie.r)
						{
							case Resultat.j1gagne: score1[j]++; break;
							case Resultat.j0gagne: score0[i]++; break;

						}
						nbitMoy[i] += partici[i].Nbitmoy;
						nbitMoy[j] += partici[j].Nbitmoy;
                        if (p is PositionPearl) { PositionPearl.feuilles = new SortedDictionary<Numero, byte>(); }
                    }
                }

                for (int i = 0; i < nbJ; i++)
                {
                    score[i] = score0[i] + score1[i];
                }
                Array.Sort((float[])score.Clone(), nbitMoy);
                Array.Sort((float[])score.Clone(), partici);
                Array.Sort((float[])score.Clone(), score0); Array.Sort(score, score1);
                Console.WriteLine("*****************************************************");
                Console.WriteLine("Tour " + k);
                for (int i = 0; i < nbJ; i++)
                {
                    double aux = score[i] / (k * 2 * (nbJ - 1.0));
                    double r = Math.Sqrt((nbJ - 1) * Math.Log(2 / .01) / k) / (2 * (nbJ - 1.0));
                    //Console.WriteLine(partici[i] + " " + score[i]+"  "+aux+" ±"+r);
                    Console.WriteLine("{0}  {1}+{2}={3}  {4}± {5}  {6}", partici[i], score1[i], score0[i], score[i], aux, r, nbitMoy[i] / (k * (nbJ - 1) * 2));

                }
                //Console.ReadKey();

            }

            Array.Sort((float[])score.Clone(), nbitMoy);
            Array.Sort((float[])score.Clone(), partici);
            Array.Sort((float[])score.Clone(), score0); Array.Sort(score, score1);
            Console.WriteLine("*****************************************************");
            Console.WriteLine("Tour " + nbTour);
            for (int i = 0; i < nbJ; i++)
            {
                int k = nbTour;
                double aux = score[i] / (k * 2 * (nbJ - 1.0));
                double r = Math.Sqrt((nbJ - 1) * Math.Log(2 / .01) / k) / (2 * (nbJ - 1.0));
                //Console.WriteLine(partici[i] + " " + score[i]+"  "+aux+" ±"+r);
                Console.WriteLine("{0}  {1}+{2}={3}  {4}± {5}  {6}", partici[i], score1[i], score0[i], score[i], aux, r, nbitMoy[i] / (k * (nbJ - 1) * 2));
                Console.WriteLine("**********************");
            }

        }
    }
}
