﻿using System;
namespace DF
{
	public enum Resultat { j1gagne, j0gagne, partieNulle, indetermine }

	public abstract class Position
	{
		public bool j1aletrait;
		public Position(bool j1aletrait) { this.j1aletrait = j1aletrait; }
		public  Resultat Eval { get; protected set; }
		public int NbCoups { get; protected set; }
		public int Profondeur { get; protected set; }
		public abstract Position PositionFille(int i);
		public abstract void Affiche();
	}

	public class Partie
	{
		Position pCourante;
		Joueur j1, j0;
		public Resultat r;

		public Partie(Joueur j1, Joueur j0, Position pInitiale)
		{
			this.j1 = j1;
			this.j0 = j0;
			pCourante = pInitiale;
		}

		public void NouveauMatch(Position pInitiale){
			pCourante = pInitiale;
		}

		public void Commencer(bool affichage = false)
		{
			j1.NouvellePartie();
			j0.NouvellePartie();

			do
			{
				if (affichage) pCourante.Affiche();
				if (pCourante.j1aletrait)
				{
					pCourante = pCourante.PositionFille(j1.Jouer(pCourante, affichage));
				}
				else {
					pCourante = pCourante.PositionFille(j0.Jouer(pCourante, affichage));
				}
				r = pCourante.Eval;
			} while (r == Resultat.indetermine);

			if (affichage)
			{
				pCourante.Affiche();
				switch (r)
				{
                    case Resultat.j1gagne: Console.WriteLine("j1 ({0}) a gagné.", j1); break;
                    case Resultat.j0gagne: Console.WriteLine("j0 ({0}) a gagné.", j0); break;
					case Resultat.partieNulle: Console.WriteLine("Partie nulle."); break;
				}
			}
		}
	}

	public abstract class Joueur
	{
		public abstract int Jouer(Position p, bool affichage=true);

		public abstract void NouvellePartie();

		public abstract float Nbitmoy { get;}

	}
}